<template>
  <div
    class="ob-draggable"
    draggable
    @mousedown="onMouseDown"
    @dragstart.self="onDrag"
    @dragend.self="onDragEnd"
    @dragover.prevent
    @dragenter.prevent
  >
    <div class="drag-wrap">
      <i class="icon move" />
    </div>
    <slot/>
  </div>
</template>

<script>
  export default {
    props: {
      transferData: {
        type: Object,
        required: true
      }
    },
    data() {
      return {
        isDragging: false,
        stopDragging: false
      }
    },

    methods: {
      onMouseDown(e) {
        const target = Array.from(e.target.classList);
        if (!target.includes('move')) {
          this.stopDragging = true;
        } else {
          this.stopDragging = false;
        }
      },

      onDrag (e) {
        if (!this.stopDragging) {
          this.isDragging = true
          e.dataTransfer.effectAllowed = 'move'
          e.dataTransfer.dropEffect = 'move'
          e.dataTransfer.setData('payload', JSON.stringify(this.transferData))
          setTimeout(() => {
            e.target.style.opacity = '0.5'
          }, 0)
        } else {
          e.preventDefault();
        }
      },

      onDragEnd (e) {
        this.isDragging = false
        e.target.style.opacity = '1'
      }
    }
  }
</script>

<style lang="scss" scoped>
.ob-draggable {
  display: flex;
  align-items: center;
}

.drag-wrap {
  margin-right: 10px;
  display: flex;
  justify-content: center;
  align-items: center;
  color: $color-grey-border;
  cursor: grab;
}
</style>